﻿using System;
using System.Runtime.ExceptionServices;
using System.Runtime.InteropServices;
using System.Threading;

class Program
{
    static void Main(string[] args)
    {
        // Test1();
        Test2();
    }

    private static void Test2()
    {
        Method1();
    }

    [HandleProcessCorruptedStateExceptions]
    private static void Method1()
    {
        try
        {
            Method2();
        }
        finally
        {
            Console.WriteLine("Method 1");
        }
    }

    private static void Method2()
    {
        try
        {
            Method3();
        }
        finally
        {
            Console.WriteLine("Method 2");
        }
    }

    private static void Method3()
    {
        // throw new ApplicationException("TEST");
        Marshal.Copy(new byte[] { 42 }, 0, (IntPtr)1000, 1);
    }


    private static void Test1()
    {
        try
        {
            //Thread t = new Thread(MyMethod);
            //t.Start();

            Thread.Sleep(1000 * 5);
            Environment.FailFast("FailFast called!");
        }
        finally
        {
            Console.WriteLine("Finally");
        }
    }

    private static void MyMethod()
    {
        Console.WriteLine("Terminate this!");
        Thread.Sleep(1000 * 60);
    }
}
